

:INDENT_PAUSE
	set bat_indent_pause=
	echo.!bat_pushstring!Press [Enter] to continue, or [variable name]. Ctrl+C to Exit or [A]bort with environment variables [%*]
	set /p bat_indent_pause=.!bat_pushstring!%*
	echo.bat_indent_pause=[!bat_indent_pause!]

	if "!bat_indent_pause!" equ "a" goto :INDENT_PAUSE_ABORT
	if "!bat_indent_pause!" equ "" goto :INDENT_PAUSE_END
	
	if /i "!bat_indent_pause:~0,5!" equ "goto " (
		!bat_return!&!bat_indent_pause!
		echo.
		echo.!bat_pushstring!indent_pause.bat:GOTO :EOF - !bat_indent_pause!
		echo.
	)
	
	if /i "!bat_indent_pause!" equ "?" (
		CALL :HELP
		goto :INDENT_PAUSE
	)

	set !bat_indent_pause!
	goto :INDENT_PAUSE
:INDENT_PAUSE_END
!bat_return!



:INDENT_PAUSE_ABORT
		REM force a syntax error in orderto guarantee that all loops and subroutines are aborted asap.
	for /f "useback" a in (1,1,1) do (x)

:INDENT_PAUSE_ABORT_END
!bat_return!


:HELP
	!bat_push!
	echo.!bat_pushstring!Instructions:
	echo.
	echo.!bat_pushstring!Usage: !bat_pause! The value of bat_xyz=[^!bat_xyz^!]
	echo.
	echo.!bat_pushstring!Ideal for debugging batch scripts.
	echo.
	echo.!bat_pushstring!It Displays:
	echo.!bat_pushstring!	^<indent spacing^>Press [Enter] to continue, Any char to abort [^<argument list^>]
	echo.!bat_pushstring!	^<indent spacing^>^<argument list^>
	echo.	
	echo.!bat_pushstring!When the user presses [Enter], it returns.
	echo.
	echo.!bat_pushstring!If the user enters an environment variable name, or part of a variable name, 
	echo.!bat_pushstring!the variable[s] and their values are listed.
	echo.
	echo.!bat_pushstring!When the user presses any other key, it forces a syntax error and aborts. When 
	echo.!bat_pushstring!that happens, the dos prompt is displayed, however, even though SETLOCAL was 
	echo.!bat_pushstring!used, the environment variables are still set - for you to examine. 
	echo.
	!bat_pop!
!bat_return!