@echo off
setlocal enableextensions enabledelayedexpansion

:SETUP
	call "%~dp0AutoCams.setup.bat" "%~dpnx0"
	call "%~dp0indent_setup.bat"
	set bat_pushstring=

	call "!bat_exedir!\ReadParams.bat"

	!bat_echolog!
	!bat_echolog! =============================================================
	!bat_echolog! %date% %time% - Version: !bat_vers! - %~dpnx0 [%*]
	!bat_echolog! [!bat_batchfile!:SETUP %*]  Please wait...
	!bat_pushecho!
	


	set bat_detectfile=!bat_exedir!\ArchivedFiles\2011_09_15_02_30_18\ftpdetectinfo.3.txt

	echo.
	find /c /i ".txt" "!bat_detectfile!"
	echo.
	echo.

	set bat_starttime=!date! !time!
	echo.[!bat_starttime!] Starting :READFILE_TYPE... 
	call :READFILE_TYPE %*
	set bat_endtime=!date! !time!
	echo.[!bat_endtime!] ... Done with :READFILE_TYPE 
	echo.
	echo.
	echo.    End Time: !bat_endtime!
	echo.  Start Time: !bat_starttime!
	echo.
	echo.

:MAIN_FIND
	if exist "!bat_exedir!\Logs\CalFileList.log" (
		del "!bat_exedir!\Logs\CalFileList.log"	
	)

	set bat_starttime=!date! !time!
	echo.[!bat_starttime!] Starting :READFILE_FIND... 
	call :READFILE_FIND %*
	set bat_endtime=!date! !time!
	echo.[!bat_endtime!] ... Done with :READFILE_FIND 
	echo.
	echo.
	echo.    End Time: !bat_endtime!
	echo.  Start Time: !bat_starttime!
	echo.
	echo.
goto :DONE



:READFILE_TYPE
	set /a bat_linecount=0
	for /f "usebackq tokens=* " %%b in (`type "!bat_detectfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		set /a bat_linecount+=1
		
		if !bat_linecount! equ 1 (
			echo.call :GETMETEORCOUNT bat_countscanned %%b
		) else (
			if !bat_linecount! equ 5 (
				echo.call :GETFFDIR "%%b"
			) else (
				if !bat_linecount! equ 6 (
					echo.rem call :GETCALDIR "%%b"
				) else (
					if !bat_linecount! equ 13 (
						echo.call :GETCAMERA
						set bat_fffilename=%%b
						echo.call :GETFFFILENAME %%b
						rem !bat_log! '  bat_FFfilename=!bat_fffilename!
						title !bat_fffilename!
					) else (
						if !bat_linecount! equ 14 (
							call :GETCALNAME "%%b"
							echo.'  bat_calfilename="!bat_calfilename!"
							echo.'1.  ADDING TO "CalFileList.log": !bat_calfilename!
							echo.!bat_calfilename!>"!bat_exedir!\Logs\CalFileList.log"
							echo.!bat_calfilename!
							set bat_calfilename_prev=!bat_calfilename!
						) else (
							if !bat_linecount! gtr 14 (
								if "!bat_tempcal:~0,3!" equ "CAL" (
									if "!bat_tempcal:~6,1!" equ "_" (
										set bat_camera_temp=!bat_tempcal:~3,3!
										call :GETCALNAME "%%b"
										rem echo '      !bat_calfilename!

										call :CHECK_CALFILELIST "!bat_calfilename!"
										if not defined bat_calfilelist_found (
											!bat_log! '  bat_calfilename="!bat_calfilename!"
											!bat_log! '2.  ADDING TO "CalFileList.log": !bat_calfilename!
											echo.!bat_calfilename!>>"!bat_exedir!\Logs\CalFileList.log"
											set bat_calfilename_prev=!bat_calfilename!
										)
									)
								)
							) else (
								if "!bat_temp!" equ "FF!bat_camera_temp!" (
									set bat_fffilename=%%b
									title working on FF file: "!bat_fffilename!"
									set /a bat_filecount+=1
								)
							)
						)
					)
				)
			)
		)
	)
goto :EOF	
	
	
:READFILE_FIND
	set /a bat_linecount=0
	
	
	!bat_pushecho! METEOR COUNT
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "Meteor Count" "!bat_detectfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETMETEORCOUNT bat_countscanned %%b
		!bat_echo! Meteor Count=!bat_countscanned!
	)
	!bat_popecho!
	
	!bat_pushecho! FF DIR
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "FF  folder" "!bat_detectfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETFFDIR "%%b"
	)
	!bat_popecho!
	
	!bat_pushecho! CAL DIR
	for /f "usebackq tokens=* skip=2" %%b in (`find /i "CAL folder" "!bat_detectfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!
		
		call :GETCALDIR "%%b"
	)
	!bat_popecho!
	
	!bat_pushecho! CalFileList
	set /a bat_linecount=0
	for /f "usebackq tokens=* skip=2" %%b in (`find /i ".txt" "!bat_detectfile!"`) do (
		set bat_temp=%%b
		set bat_temp=!bat_temp:~0,7!
		set bat_tempcal=!bat_temp:~0,7!

		set /a bat_linecount+=1

		if !bat_linecount! equ 1 (
			call :GETCALNAME "%%b"
			echo.'  bat_calfilename="!bat_calfilename!"
			echo.'1.  ADDING TO "CalFileList.log": !bat_calfilename!
			echo.!bat_calfilename!>"!bat_exedir!\Logs\CalFileList.log"
			echo.!bat_calfilename!
			set bat_calfilename_prev=!bat_calfilename!
		) else (
			if !bat_linecount! gtr 1 (
				if "!bat_tempcal:~0,3!" equ "CAL" (
					if "!bat_tempcal:~6,1!" equ "_" (
						set bat_camera_temp=!bat_tempcal:~3,3!
						call :GETCALNAME "%%b"
						rem echo '      !bat_calfilename!

						call :CHECK_CALFILELIST "!bat_calfilename!"
						if not defined bat_calfilelist_found (
							!bat_log! '  bat_calfilename="!bat_calfilename!"
							!bat_log! '2.  ADDING TO "CalFileList.log": !bat_calfilename!
							echo.!bat_calfilename!>>"!bat_exedir!\Logs\CalFileList.log"
							set bat_calfilename_prev=!bat_calfilename!
						)
					)
				)
			) else (
				if "!bat_temp!" equ "Cal!bat_camera_temp!" (
					set bat_fffilename=%%b
					title working on Cal file: "!bat_fffilename!"
					set /a bat_filecount+=1
				)
			)
		)
	)
	!bat_popecho!
	

goto :EOF	
	





	rem Check "CalFileList.log" to see if %~1 already exists in the list
	rem Returns: bat_calfilelist_found=true if found, otherwise, it is undefined
:CHECK_CALFILELIST [in]  "!bat_calfilename!"
               rem [out] bat_calfilelist_found
	set bat_calfilelist_found=
	for /f "usebackq tokens=*" %%x in (`type "!bat_exedir!\Logs\CalFileList.log"`) do (
		if /i "%~1"  equ "%%x" (
			set bat_calfilelist_found=true
		)
	)
:CHECK_CALFILELIST_END
rem echo [RETURN !bat_batchfile!:CHECK_CALFILELIST] [%~1, bat_calfilelist_found=!bat_calfilelist_found!]
!bat_return!




:GETCALNAME
rem !bat_pushlog!  [CALL !bat_batchfile!:GETCALNAME] %*
	rem 
	set bat_calfilename=%~1
rem !bat_poplog!  [RETURN !bat_batchfile!:GETCALNAME] %*  [!bat_calfilename!]
!bat_return!


:GETMETEORCOUNT
!bat_pushecho! [CALL !bat_batchfile!:GETMETEORCOUNT] %*
	rem Usage: call :GETMETEORCOUNT {return variable name} Meteor Count = 000533
	
	set bat_temp=%4
	echo.set bat_temp=%4
	if "!bat_temp!" equ "000000" (
		echo.set bat_msg=; needs FTP_Reprocess
		set bat_msg=; needs FTP_Reprocess
	)

	rem Strip leading zeros
	echo.for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	for /f "tokens=* delims=0" %%a in ("!bat_temp!") do (set %1=%%a)
	if not defined %1 set %1=0
!bat_popecho! [RETURN !bat_batchfile!:GETMETEORCOUNT] [!%1!] [%*] 
!bat_log!
!bat_return!


:GETCALDIR
!bat_pushecho!  [CALL !bat_batchfile!:GETCALDIR] %*
	rem Usage: call :GETCALDIR "CAL folder = c:\CAMS\Cal\"
	rem Called when reaing FTPdetectinfo.txt line 6 to fetch the Cal folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_caldir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_popecho!  [RETURN !bat_batchfile!:GETCALDIR] [!bat_caldir!] [%*] 
!bat_log!
!bat_return!


:GETFFDIR
!bat_pushecho!  [CALL !bat_batchfile!:GETFFDIR] %*
	rem Usage: call :GETFFDIR "FF  folder = c:\CAMS\ArchivedFiles\2011_08_05_04_40_44\"
	rem Called when reaing FTPdetectinfo.txt line 5 to fetch the FF folder.
	for /f "tokens=1,2* delims=\= " %%b in (%1) do (
		set bat_temp2=%%d
		set bat_ffdir=!bat_temp2:C:=%bat_startdrive%!
	)
!bat_popecho!  [RETURN !bat_batchfile!:GETFFDIR] %*  [!bat_ffdir!]
!bat_log!
!bat_return!








:DONE
echo.
!bat_popecho! DONE
echo.
